Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 590681 - Review Request: objenesis - A library for instantiating Java objects
Summary: Review Request: objenesis - A library for instantiating Java objects
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Alexander Kurtakov
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 590680
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-05-10 13:25 UTC by Guido Grazioli
Modified: 2011-06-02 18:52 UTC (History)
4 users (show)

Fixed In Version: objenesis-1.2-7.fc15
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-05-09 11:25:21 UTC
akurtako: fedora-review+
tibbs: fedora-cvs+


Attachments (Terms of Use)

Description Guido Grazioli 2010-05-10 13:25:26 UTC
Spec URL: 
http://guidograzioli.fedorapeople.org/packages/objenesis/objenesis.spec
SRPM URL: 
http://guidograzioli.fedorapeople.org/packages/objenesis/objenesis-1.2-1.fc14.src.rpm
Description: 
Java supports dynamic instantiation of classes using Class.newInstance(). 
However, this only works if the class has an appropriate constructor. There 
are many times when a class cannot be instantiated this way, such as when 
the class contains:
* Constructors that require arguments.
* Constructors that have side effects.
* Constructors that throw exceptions.
As a result, it is common to see restrictions in libraries stating that 
classes must require a default constructor. Objenesis aims to overcome these 
restrictions by bypassing the constructor on object instantiation.
Needing to instantiate an object without calling the constructor is a fairly 
specialized task, however there are certain cases when this is useful:
* Serialization, Remoting and Persistence - Objects need to be instantiated 
  and restored to a specific state, without invoking code.
* Proxies, AOP Libraries and Mock Objects - Classes can be subclassed without 
  needing to worry about the super() constructor.
* Container Frameworks - Objects can be dynamically instantiated in 
  non-standard ways.

Comment 1 Alexander Kurtakov 2010-11-18 20:39:34 UTC
Guido,
Do you still want someone to do the review?

Comment 2 Guido Grazioli 2010-11-18 21:15:05 UTC
Sure, objenesis 1.2 is still the latest release, but the specfile needs updates for the brand new guidelines and i dont know if it currently builds on rawhide as i only use it on a f13. Will follow up as soon i have things sorted

Comment 4 Alexander Kurtakov 2011-01-18 08:02:30 UTC
Few comments:
* Drop buildroot
* Drop clean section
* Don't install versioned jars
* Do we really need maven2-settings.xml and all the sed edits?
* Does it build with maven 3? If yes please switch to using it.

Comment 5 Guido Grazioli 2011-02-04 13:26:41 UTC
(In reply to comment #4)
> Few comments:
> * Drop buildroot
> * Drop clean section
> * Don't install versioned jars
> * Do we really need maven2-settings.xml and all the sed edits?
> * Does it build with maven 3? If yes please switch to using it.

ok i did a major cleanup of the specfile and tested the build with maven3, which completed successfully:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2761796
(maven2 is still pulled in the package sack for some dependency though)

SPEC and SRPM: 
http://guidograzioli.fedorapeople.org/packages/objenesis/

Comment 6 Alexander Kurtakov 2011-02-17 18:47:30 UTC
I'll do this one.

Comment 7 Alexander Kurtakov 2011-02-17 19:11:30 UTC
Package Review
==============

Key:
- = N/A
x = Check
! = Problem
? = Not evaluated

=== REQUIRED ITEMS ===
[x]  Rpmlint output:
objenesis.noarch: W: spelling-error %description -l en_US newInstance -> new Instance, new-instance, instance
objenesis.noarch: W: spelling-error %description -l en_US subclassed -> subclasses, sub classed, sub-classed
objenesis.noarch: W: non-conffile-in-etc /etc/maven/fragments/objenesis
Not a problem
[x]  Package is named according to the Package Naming Guidelines[1].
[x]  Spec file name must match the base package name, in the format %{name}.spec.
[x]  Package meets the Packaging Guidelines[2].
[x]  Package successfully compiles and builds into binary rpms.
[x]  Buildroot definition is not present
[x]  Package is licensed with an open-source compatible license and meets other legal requirements as defined in the legal section of Packaging Guidelines[3,4].
[!]  License field in the package spec file matches the actual license.
License type: MIT in spec, ASL 2.0 actually
[-]  If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package is included in %doc.
[-]  All independent sub-packages have license of their own
[x]  Spec file is legible and written in American English.
[-]  Sources used to build the package matches the upstream source, as provided in the spec URL.
[x]  All build dependencies are listed in BuildRequires, except for any that are listed in the exceptions section of Packaging Guidelines[5].
[x]  Package must own all directories that it creates.
[x]  Package requires other packages for directories it uses.
[x]  Package does not contain duplicates in %files.
[x]  Permissions on files are set properly.
[x]  Package does NOT have a %clean section which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). (not needed anymore)
[x]  Package consistently uses macros (no %{buildroot} and $RPM_BUILD_ROOT mixing)
[x]  Package contains code, or permissable content.
[x]  Fully versioned dependency in subpackages, if present.
[-]  Package contains a properly installed %{name}.desktop file if it is a GUI application.
[x]  Package does not own files or directories owned by other packages.
[x]  Javadoc documentation files are generated and included in -javadoc subpackage
[x]  Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlinks)
[x]  Packages have proper BuildRequires/Requires on jpackage-utils
[x]  Javadoc subpackages have Require: jpackage-utils
[x]  Package uses %global not %define
[x]  If package uses tarball from VCS include comment how to re-create that tarball (svn export URL, git clone URL, ...)
[-]  If source tarball includes bundled jar/class files these need to be removed prior to building
[x]  All filenames in rpm packages must be valid UTF-8.
[x]  Jar files are installed to %{_javadir}/%{name}.jar (see [6] for details)
[x]  If package contains pom.xml files install it (including depmaps) even when building with ant
[x]  pom files has correct add_to_maven_depmap call which resolves to the pom file (use "JPP." and "JPP-" correctly)

=== Maven ===
[x]  Use %{_mavenpomdir} macro for placing pom files instead of %{_datadir}/maven2/poms
[!]  If package uses "-Dmaven.test.skip=true" explain why it was needed in a comment!
Please comment
[-]  If package uses custom depmap "-Dmaven2.jpp.depmap.file=*" explain why it's needed in a comment
[x]  Package uses %update_maven_depmap in %post/%postun
[x]  Packages have Requires(post) and Requires(postun) on jpackage-utils (for %update_maven_depmap macro)

=== Other suggestions ===
[x]  If possible use upstream build method (maven/ant/javac)
[x]  Avoid having BuildRequires on exact NVR unless necessary
[x]  Package has BuildArch: noarch (if possible)
[x]  Latest version is packaged.

=== Issues ===
1. License field in the spec is wrong.
2. Please comment why tests are skipped
3. Please mvn-rpmbuild instead of mvn-local it is supposed to exactly what we need for rpm builds.

Comment 8 Guido Grazioli 2011-02-24 09:38:17 UTC
Thanks, fixed.
SPEC and SRPM: http://guidograzioli.fedorapeople.org/packages/objenesis/

Comment 9 Alexander Kurtakov 2011-02-24 09:51:42 UTC
Looks good.

APPROVED

Comment 10 Guido Grazioli 2011-02-24 14:35:32 UTC
New Package SCM Request
=======================
Package Name: objenesis
Short Description: A library for instantiating Java objects
Owners: guidograzioli
Branches: F-14 F-15
InitialCC: java-sig

Thanks

Comment 11 Jason Tibbitts 2011-02-24 18:26:38 UTC
This ticket is not assigned to anyone.  It should be assigned to the reviewer.

Please fix and re-raise the fedora-cvs flag.

Comment 12 Alexander Kurtakov 2011-02-24 18:35:56 UTC
Sorry about that, I forgot to assign the bug to me.

Comment 13 Guido Grazioli 2011-02-24 19:37:00 UTC
It passed unnoticed under my eyes too, sorry for that.

Comment 14 Jason Tibbitts 2011-02-25 03:09:31 UTC
Git done (by process-git-requests).

Comment 15 Alexander Kurtakov 2011-03-23 13:33:14 UTC
Guido, would you please close the bug if you have built it?

Comment 16 Orion Poplawski 2011-05-05 05:29:57 UTC
Guido - looks like a F15 build has been done, but you need to submit an update.  Please do so.  I need objenesis for some stuff I'm looking to package.

Comment 17 Fedora Update System 2011-05-09 11:23:44 UTC
objenesis-1.2-7.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/objenesis-1.2-7.fc15

Comment 18 Guido Grazioli 2011-05-09 11:25:21 UTC
build done, closing

Comment 19 Fedora Update System 2011-06-02 18:51:59 UTC
objenesis-1.2-7.fc15 has been pushed to the Fedora 15 stable repository.


Note You need to log in before you can comment on or make changes to this bug.